package org.beigesoft.web.service;

/*
 * Copyright (c) 2018 Beigesoft ™
 *
 * Licensed under the GNU General Public License (GPL), Version 2.0
 * (the "License");
 * you may not use this file except in compliance with the License.
 *
 * You may obtain a copy of the License at
 *
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html
 */

/**
 * <p>Abstraction of service that listen to user password has been changed,
 * e.g. for clear users credentials cache in Jetty.</p>
 *
 * @author Yury Demidenko
 */
public interface ILstnUserPswdChanged {

  /**
   * <p>Password changed event.</p>
   * @param pUserName User Name
   * @throws Exception - an exception
   **/
  void passwordChanged(String pUserName) throws Exception;
}
